#include "conversion.h"

#include "RGtk2.h"


void * getPtrValue(USER_OBJECT_ sval)
{
  if(sval == NULL_USER_OBJECT)
    return(NULL);
  return(R_ExternalPtrAddr(sval));
}


USER_OBJECT_  S_get_image_data_from_file (  USER_OBJECT_ s_filename )
{
  char * filename = CHAR_DEREF( STRING_ELT( s_filename , 0)) ;
  GdkPixbuf * image=gdk_pixbuf_new_from_file ( filename , NULL); 
  USER_OBJECT_ sarg = NULL_USER_OBJECT; 
  int i,j,k,l;
  guchar * z;
  SEXP dims;
  if (!image) { return(sarg);};
  PROTECT(dims= allocVector(INTSXP,3));
  INTEGER(dims)[0]=gdk_pixbuf_get_width(image);
  printf("%i\n",INTEGER(dims)[0]);
  INTEGER(dims)[1]=gdk_pixbuf_get_height(image);
  printf("%i\n",INTEGER(dims)[0]);
  INTEGER(dims)[2]=gdk_pixbuf_get_n_channels(image);
  printf("%i\n",INTEGER(dims)[0]);
  l=gdk_pixbuf_get_rowstride(image);
  printf("width=%i height=%i\n rowstride=%i bits per sample = %i\n",INTEGER(dims)[0],INTEGER(dims)[1],l,gdk_pixbuf_get_bits_per_sample(image));
  z=gdk_pixbuf_get_pixels(image);
  PROTECT(sarg=allocArray(REALSXP,dims));
  for (i=0;i<INTEGER(dims)[0];i++){
    for (j=0;j<INTEGER(dims)[1];j++){
      for (k=0;k<INTEGER(dims)[2];k++){
	REAL(sarg)[k*INTEGER(dims)[1]*INTEGER(dims)[0]+i*INTEGER(dims)[1]+j]=(double)(*z);
	z++;
      }
      z=z+l-3*INTEGER(dims)[0];
    }
  }   
  UNPROTECT(2);
  free(image);
  return(sarg); 
}


USER_OBJECT_ S_gtk_image_set_array (  USER_OBJECT_ s_image, USER_OBJECT_ _array) {
  SEXP sarg= NULL_USER_OBJECT;
  GdkPixbuf * image;
  guchar *z ;
  int i,j,k,l,size,planes;
  int planes_offset=-1;
  SEXP dims=getAttrib(_array, R_DimSymbol);
  GtkImage * widget = getPtrValue( s_image ) ;
  size=LENGTH(dims);
  if (size==2) {
    /*greyscale image*/
    planes_offset=0;
    planes=1;
  }
  if (size==3) {
    if (INTEGER(dims)[2]==1) {
      /*still greyscale image*/
      planes_offset=0;
      planes=1;
    }
    if (INTEGER(dims)[2]==3) {
      /*rgb image*/
      planes_offset=INTEGER(dims)[1]*INTEGER(dims)[0];
      planes=3;
    }
  }
  if (planes_offset<0) {
    /*not an image*/
    return(sarg);
  }
  if (planes_offset==0){
    /*mark widget as having greyscale image*/
    gtk_object_set_user_data(widget,1);
  } else {
    gtk_object_set_user_data(widget,NULL);
  }
  image=gdk_pixbuf_new(GDK_COLORSPACE_RGB,0,8,INTEGER(dims)[1],INTEGER(dims)[0]);
  if (!image) { return(sarg); };
  l=gdk_pixbuf_get_rowstride(image);
  z=gdk_pixbuf_get_pixels(image);
  for (i=0;i<INTEGER(dims)[0];i++){
    for (j=0;j<INTEGER(dims)[1];j++){
      for (k=0;k<3;k++){
	/*image array should be (at least we hope so) in range 0.0-1.0*/
	(*z)=(guchar)(REAL(_array)[k*planes_offset+j*INTEGER(dims)[0]+i]*255.0);
	z++;
      }
    }
    z=z+l-3*INTEGER(dims)[1];
  }
  gtk_image_set_from_pixbuf(widget,image);
  //  gdk_pixbuf_unref(image);
  return(dims);
}
 

USER_OBJECT_ S_gtk_image_get_array (  USER_OBJECT_ s_image)
{
  SEXP sarg= NULL_USER_OBJECT;
  GdkPixbuf * image;
  guchar *z ;
  int rgb_dim=1;
  int i,j,k,l;
  SEXP dims;
  GtkImage * widget = getPtrValue( s_image ) ;   
  g_object_get(widget,"pixbuf",&image,NULL);
  if (!image) { return(sarg);};
  if (gtk_object_get_user_data(widget)==NULL) {
    /*is rgb*/
    PROTECT(dims= allocVector(INTSXP,3));
    INTEGER(dims)[2]=gdk_pixbuf_get_n_channels(image);
    rgb_dim=INTEGER(dims)[2];
  } else {
    /*is greyscale*/
    PROTECT(dims= allocVector(INTSXP,2));     
  }   
  INTEGER(dims)[1]=gdk_pixbuf_get_width(image);
  INTEGER(dims)[0]=gdk_pixbuf_get_height(image);  
  l=gdk_pixbuf_get_rowstride(image);
  z=gdk_pixbuf_get_pixels(image);
  PROTECT(sarg=allocArray(REALSXP,dims));
  for (j=0;j<INTEGER(dims)[0];j++){
    for (i=0;i<INTEGER(dims)[1];i++){
      for (k=0;k<rgb_dim;k++){
	/*clamp to 0.0-1.0 range*/
	REAL(sarg)[k*INTEGER(dims)[1]*INTEGER(dims)[0]+i*INTEGER(dims)[0]+j]=((double)(*z)/255.0);
	z++;
      }
    }
    z=z+l-rgb_dim*INTEGER(dims)[1];
  }  
  UNPROTECT(2);
  return(sarg); 
}

